<!--
===============================================
vidgear library source-code is deployed under the Apache 2.0 License:

Copyright (c) 2019-2020 Abhishek Thakur(@abhiTronix) <abhi.una12@gmail.com>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
===============================================
-->

<img src="docs/overrides/assets/images/contribute.webp" alt="VidGear Contribution" loading="lazy" class="center" />


# Contribution Overview


Contributions are welcome, We'd love your contribution to VidGear in order to fix bugs or to implement new features!

> 💡 If you're looking for something to work on, check for the [PR WELCOMED :mailbox_with_mail:](https://github.com/abhiTronix/vidgear/issues?q=is%3Aissue+is%3Aopen+label%3A%22PR+WELCOMED+%3Amailbox_with_mail%3A%22) labeled issues on our GitHub Repository.

&thinsp;

## Submission Contexts

### Got a question or problem?

For quick questions, please refrain from opening an issue, instead read our [FAQ & Troubleshooting](https://abhitronix.github.io/vidgear/latest/help/get_help/#frequently-asked-questions) section or you can reach us on [Gitter](https://gitter.im/vidgear/community) community channel.


### Found a typo?

There's no need to contribute for some typos. Just reach us on [Gitter ➶](https://gitter.im/vidgear/community) community channel, We will correct them in (less than) no time. 


### Found a bug?

If you encountered a bug, you can help us by submitting an issue in our GitHub repository. Even better, you can submit a Pull Request(PR) with a fix, but make sure to read the [guidelines ➶](#submission-guidelines).


### Request for a feature/improvement?

> 💡 You can [subscribe our GitHub Repository](https://github.com/abhiTronix/vidgear/watchers) to receive notifications through email for new pull requests, commits and issues that are created in VidGear. _Learn more about it [here ➶](https://help.github.com/en/github/managing-subscriptions-and-notifications-on-github/viewing-your-subscriptions)_

You can request our GitHub Repository for a new feature/improvement based on the type of request:

> Please [submit an issue with a proposal template](https://github.com/abhiTronix/vidgear/issues/new?labels=issue%3A+proposal&template=proposal.md) for your request to explain how it benefits everyone in the community.

* **Major Feature Requests:** If you require a major feature for VidGear, then first [open an issue](https://abhitronix.github.io/vidgear/latest/contribution/issue/) and outline your proposal so that it can be discussed. This will also allow us to better coordinate our efforts, prevent duplication of work, and help you to craft the change so that it is successfully accepted into the project. The purposed feature, if accepted, may take time based on its complexity and availability/time-schedule of our maintainers, but once it's completed, you will be notified right away. Please be patient! 

* **Minor Feature Requests:**  Small features and bugs resolved on priority. You just have to [submit an issue](https://abhitronix.github.io/vidgear/latest/contribution/issue/) to our GitHub Repository.

&thinsp;

## Submission Guidelines

- [Submitting an Issue Guidelines](https://abhitronix.github.io/vidgear/latest/contribution/issue/)
- [Submitting Pull Request(PR) Guidelines](https://abhitronix.github.io/vidgear/latest/contribution/PR/)


&thinsp;

## Community Channel

If you've come up with some new idea, or looking for the fastest way troubleshoot your problems, then please **join our [Gitter community channel][gitter]**.

&thinsp;

## Become a Stargazer

You can be a [**Stargazer 🌟**][stargazer] by starring this framework, it helps us a lot and **you're making it easier for others to find & trust this library.** Thanks!

&thinsp;
 

## Love using VidGear? 

> VidGear relies on your support :heart:

Donations help keep VidGear's Development alive. Giving a little means a lot, even the smallest contribution can make a huge difference.


[![ko-fi][kofi-badge]][kofi]


<!--
Internal URLs
-->
[Coffee-badge]:https://abhitronix.github.io/img/vidgear/orange_img.png
[coffee]:https://www.buymeacoffee.com/2twOXFvlA
[kofi-badge]:https://www.ko-fi.com/img/githubbutton_sm.svg
[kofi]: https://ko-fi.com/W7W8WTYO
[gitter]:https://gitter.im/vidgear/community
[stargazer]: https://github.com/abhiTronix/vidgear/stargazers