<!--
===============================================
vidgear library source-code is deployed under the Apache 2.0 License:

Copyright (c) 2019-2020 Abhishek Thakur(@abhiTronix) <abhi.una12@gmail.com>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
===============================================
-->

# Getting Help

<figure>
<img src="https://i.pinimg.com/originals/d1/1a/0e/d11a0e5f0616e5ce74ebf0dd7ec5594f.gif" loading="lazy" alt="Getting help"/>
<figcaption>Courtesy - <a href="https://www.pinterest.com/pin/435019645249342748/">Pinterest</a></figcaption>
</figure>

> Would you like to get help with VidGear?

There are several ways to get help with VidGear:


&thinsp;


## Frequently Asked Questions

> Got a question related to VidGear Working?  

Checkout our Frequently Asked Questions, a curated list of all the questions with adequate answer that we commonly receive, for quickly troubleshooting your problems:

- [General FAQs ➶](general_faqs.md)
- [CamGear FAQs ➶](camgear_faqs.md)
- [PiGear FAQs ➶](pigear_faqs.md)
- [ScreenGear FAQs ➶](screengear_faqs.md)
- [StreamGear FAQs ➶](streamgear_faqs.md)
- [WriteGear FAQs ➶](writegear_faqs.md)
- [NetGear FAQs ➶](netgear_faqs.md)
- [WebGear FAQs ➶](webgear_faqs.md)
- [WebGear_RTC FAQs ➶](webgear_rtc_faqs.md)
- [VideoGear FAQs ➶](videogear_faqs.md)
- [Stabilizer Class FAQs ➶](stabilizer_faqs.md)
- [NetGear_Async FAQs ➶](netgear_async_faqs.md)


&thinsp;


## Join our Gitter Community channel

> Have you come up with some new idea 💡 or looking for the fastest way troubleshoot your problems

**Join and chat on our Gitter Community channel:** [![Glitter chat](https://img.shields.io/badge/Chat&nbsp;on-Gitter-yellow.svg?style=flat-square&logo=gitter)](https://gitter.im/vidgear/community)

There you can ask quick questions, swiftly troubleshoot your problems, help others, share ideas & information, etc. 


&thinsp;


## This is what you do when...

- [x] [Got a question or problem?](../../contribution/#got-a-question-or-problem)
- [x] [Found a typo?](../../contribution/#found-a-typo)
- [x] [Found a bug?](../../contribution/#found-a-bug)
- [x] [Missing a feature/improvement?](../../contribution/#request-for-a-featureimprovementt)


&thinsp;


## Reporting an issues

> Want to report a bug? Suggest a new feature?

Before you do, please read our [guidelines ➶](../../contribution/issue/)


&thinsp;


## Preparing a Pull Request

> Interested in contributing to VidGear?

Before you do, please read our [guidelines ➶](../../contribution/PR/)

&thinsp;